#include "Effect.h"
using namespace ffgl;
using namespace ffglex;

namespace ffglqs
{

Effect::Effect()
{
	SetMinInputs( 1 );
	SetMaxInputs( 1 );

	fragmentShaderCodeStart += R"(
// ffglqs::Effect
uniform sampler2D inputTexture;

in vec2 i_uv;

)";

	vertexShaderCode = R"(#version 410 core
// ffglqs::Effect
uniform vec2 maxUV;

layout( location = 0 ) in vec4 vPosition;
layout( location = 1 ) in vec2 vUV;

out vec2 i_uv;

void main()
{
	gl_Position = vPosition;
	i_uv = vUV * maxUV;
}
)";

}

Effect::~Effect()
{
}

FFResult Effect::Render( ProcessOpenGLStruct* inputTextures )
{
	if( inputTextures->numInputTextures < 1 )
		return FF_FAIL;
	if( inputTextures->inputTextures[ 0 ] == nullptr )
		return FF_FAIL;

	shader.Use();
	shader.BindTexture("inputTexture", 0, *inputTextures->inputTextures[ 0 ] );
	TexCoords maxCoords = GetMaxGLTexCoords( *inputTextures->inputTextures[ 0 ] );
	shader.Set( "maxUV", maxCoords.s, maxCoords.t );
	quad.Draw();
	return FF_SUCCESS;
}

}// namespace ffglqs
